package com.myoa.engineering.crawl.shopping.infra.client.fmkorea;

import com.myoa.engineering.crawl.shopping.configuration.feign.FmkoreaClientFeignConfiguration;
import io.github.resilience4j.circuitbreaker.annotation.CircuitBreaker;
import io.github.resilience4j.ratelimiter.annotation.RateLimiter;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.Map;

@FeignClient(value = "fmkorea-board-client", url = "https://www.fmkorea.com", configuration = FmkoreaClientFeignConfiguration.class)
public interface FmkoreaBoardClient {

    @CircuitBreaker(name = "fmkoreaAvoid429")
    @RateLimiter(name = "fmkoreaAvoid429")
    @GetMapping("{boardLink}")
    String getBoardHtml(@PathVariable("boardLink") String boardLink,
                        @SpringQueryMap Map<String, String> params);
}
